#pragma once

#include <a8/singleton.h>

#ifdef USE_BOOST

namespace f8
{
    class Coroutine;
    class CoMgr : public a8::Singleton<CoMgr>
    {

    private:
        CoMgr() {};
        friend class a8::Singleton<CoMgr>;

    public:

        void Init();
        void UnInit();
        void Update();

        std::weak_ptr<Coroutine> CreateCo(std::function<void(Coroutine*)> cb);

    private:
        list_head co_list_;
        list_head exec_list_;

        friend class Coroutine;
    };

}

#endif
